<?php

class ControllerPaymentCryptocloud extends Controller {
	private $error = array();

	public function index() {
		$this->language->load('payment/cryptocloud');
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST')  && $this->validate()) {
			$this->model_setting_setting->editSetting('cryptocloud', $this->request->post);
			$this->session->data['success'] = $this->language->get('text_success');
			$this->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
		}


        $this->data['heading_title'] = $this->language->get('heading_title');
        $this->data['text_edit'] = $this->language->get('text_edit');
        $this->data['text_payment'] = $this->language->get('text_payment');
        $this->data['text_cryptocloud'] = $this->language->get('text_cryptocloud');
        $this->data['text_success'] = $this->language->get('text_success');
        $this->data['text_disabled'] = $this->language->get('text_disabled');
        $this->data['text_enabled'] = $this->language->get('text_enabled');
        $this->data['text_pay'] = $this->language->get('text_pay');
        $this->data['text_response_description'] = $this->language->get('text_response_description');
        $this->data['text_enot_order_status'] = $this->language->get('text_enot_order_status');
        $this->data['text_response_code'] = $this->language->get('text_response_code');
        $this->data['entry_merchant_id'] = $this->language->get('entry_merchant_id');
        $this->data['entry_apikey'] = $this->language->get('entry_apikey');
        $this->data['entry_title'] = $this->language->get('entry_title');
        $this->data['entry_order_status'] = $this->language->get('entry_order_status');
        $this->data['entry_status'] = $this->language->get('entry_status');
        $this->data['entry_sort_order'] = $this->language->get('entry_sort_order');
        $this->data['error_permission'] = $this->language->get('error_permission');
        $this->data['error_merchant_id'] = $this->language->get('error_merchant_id');
        $this->data['error_apikey'] = $this->language->get('error_apikey');
        $this->data['button_save'] = $this->language->get('button_save');
        $this->data['button_cancel'] = $this->language->get('button_cancel');

		$arr = array("warning", "merchant_id", "apikey");
		foreach ($arr as $v) $this->data['error_' . $v] = (isset($this->error[$v])) ? $this->error[$v] : "";

		$this->data['breadcrumbs'] = array();
		$this->data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => false
		);
		$this->data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_payment'),
			'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);
		$this->data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('payment/cryptocloud', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$this->data['action'] = $this->url->link('payment/cryptocloud', 'token=' . $this->session->data['token'], 'SSL');
		$this->data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');

		$this->load->model('localisation/order_status');

		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

		$array_data = array(
			'cryptocloud_apikey',
			'cryptocloud_merchant_id',
			'cryptocloud_title',
			'cryptocloud_order_status_id',
			'cryptocloud_status',
			'cryptocloud_sort_order',
		);

		foreach ($array_data as $v) {
			$this->data[$v] = (isset($this->request->post[$v])) ? $this->request->post[$v] : $this->config->get($v);
		}

        $this->template = 'payment/cryptocloud.tpl';
        $this->children = array(
            'common/header',
            'common/footer'
        );

        $this->response->setOutput($this->render());

	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/cryptocloud')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->request->post['cryptocloud_apikey']) {
			$this->error['apikey'] = $this->language->get('error_apikey');
		}
		if (!$this->request->post['cryptocloud_merchant_id']) {
			$this->error['merchant_id'] = $this->language->get('error_merchant_id');
		}
		return (!$this->error) ? true : false;
	}
}

?>